/**
 *  Java GUI Tutorial 
 *  ScrollbarExample.java
 *
 *  @autor Gabor Nemeth, HUNGARY 2007
 *    
 *  Licence: free for non-commercial use
 *
 *  This is a sample program without guarantee and liability.
 *  
 *
 **/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class ScrollbarExample extends JFrame implements AdjustmentListener {

  private JPanel mainPanel;
  private JPanel scrollPanel;
  private JPanel colorPanel;
  private Scrollbar redScroll;
  private Scrollbar greenScroll;
  private Scrollbar blueScroll;
  private Scrollbar alphaScroll;
  
  private JLabel redLabel;
  private JLabel greenLabel;
  private JLabel blueLabel;
  private JLabel alphaLabel;
  
  
  public ScrollbarExample() {
    super("Scrollbar example"); // the superconstructor is JFrame(String title)
    this.setSize(300,180);
    
    // creating objects
    mainPanel = new JPanel();
    scrollPanel = new JPanel();
    colorPanel = new JPanel();
    redScroll = new Scrollbar(Scrollbar.HORIZONTAL, 0, 20, 0, 275); // 255+20
    greenScroll = new Scrollbar(Scrollbar.HORIZONTAL, 0, 20, 0, 275);
    blueScroll = new Scrollbar(Scrollbar.HORIZONTAL, 0, 20, 0, 275);
    
    
    // labels for showing values
    redLabel = new JLabel("Red = 0");
    greenLabel = new JLabel("Green = 0");
    blueLabel = new JLabel("Blue = 0");
    
    
    // setting the layouts
    this.getContentPane().add(mainPanel);
    mainPanel.setLayout(new GridLayout(1,2)); // two columns in one row
    scrollPanel.setLayout(new GridLayout(6,1)); // 6 rows and 1 columns
    mainPanel.add(scrollPanel);
    mainPanel.add(colorPanel);
    scrollPanel.add(redScroll);
    scrollPanel.add(redLabel);
    scrollPanel.add(greenScroll);
    scrollPanel.add(greenLabel);
    scrollPanel.add(blueScroll);
    scrollPanel.add(blueLabel);
    
    
    // adding event listeners
    redScroll.addAdjustmentListener(this);
    greenScroll.addAdjustmentListener(this);
    blueScroll.addAdjustmentListener(this);
    
    
    // intitalizing the 
    colorPanel.setBackground(new Color(0,0,0));
  }
  
  public void adjustmentValueChanged(AdjustmentEvent e) {
    // getting values from the scrollbars
    int red = redScroll.getValue();
    int green = greenScroll.getValue();
    int blue = blueScroll.getValue();
    
    
    redLabel.setText("Red = "+red);
    greenLabel.setText("Green = "+green);
    blueLabel.setText("Blue = "+blue);
    
    
    // repainting the colorPanel with new color
    colorPanel.setBackground(new Color(red, green, blue));
    colorPanel.repaint();
  }
  
  
  public static void main(String[] args) {
    ScrollbarExample frame = new ScrollbarExample();
    frame.setVisible(true);
    
    // this is an implementation of window listener
    // the program will be stopped if you close the main frame
    WindowListener listener = new WindowAdapter() {
      public void windowClosing(WindowEvent we) {
        System.exit(0);
      }
    };
    frame.addWindowListener(listener);
  }


}


